unit Un_Server;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ScktComp;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    StatusBar1: TStatusBar;
    ServerSocket1: TServerSocket;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  num_users: integer;
  s_handles: array [0..9] of integer;
  s_users:  array [0..9] of string;
  
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ServerSocket1.Active := True;
  num_users := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
// "".
begin
  ServerSocket1.Active := False;
  ServerSocket1.Close;
  Close;
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.SimpleText := '  ' +
    IntToStr(ServerSocket1.Socket.ActiveConnections)+ ' ';
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i, j, k: integer;
begin
  StatusBar1.SimpleText := '  '+
    IntToStr(ServerSocket1.Socket.ActiveConnections-1)+ ' ';
  for i := 0 to num_users-1 do
    if Socket.SocketHandle = s_handles[i] then
    begin
      k := i; break;
    end;
  for j := k+1 to num_users-1 do
  begin
    s_handles[j-1] := s_handles [ j ];
    s_users[j-1] := s_users[j];
  end;
  num_users := num_users-1;
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  str, s_send, s_rec: string;
  p1, p2, hndl, i, j, k: integer;
begin
  str  := Socket.ReceiveText;
  hndl := Socket.SocketHandle;
  ListBox1.Items.Add(str);
  p1 := pos ('|', str);
  s_send := copy ( str, 1, p1-1);
  str := copy( str, p1+1, length(str)-p1);
  p2 := pos( '|', str);
  s_rec := copy(str,1,p2-1);
  j:= -1;
  //    ,   .
  for i:=0 to num_users-1 do
  begin
     if s_handles[i]=hndl then
     begin
       j :=i;
       break;
     end;
  end;
  if j = -1 then
  //   .
  begin
    s_handles[num_users] := hndl;
    s_users[num_users]:=s_send;
    num_users := num_users+1;
  end;
  k :=  -1;
  if p2<>1 then
  //   -   .
  for i := 0 to num_users-1 do
  begin
    if CompareText(s_users[i],s_rec)=0   then
    begin
      k:=i;
      break;
    end;
  end;
  str := s_send+'|'+copy (str,p2+1,length(str)-p2);
  if p2=1 then
  begin
    //    -  .
    for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
      ServerSocket1.Socket.Connections[i].SendText(str);
  end
  else
    //   -  .
    if k = -1 then
    begin
      for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
        if ServerSocket1.Socket.Connections[i].SocketHandle = hndl then
             ServerSocket1.Socket.Connections[i].SendText(' '
                   +s_rec+'  ');
    end
    else
    begin
      //   -  .
      for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
        if ServerSocket1.Socket.Connections[i].SocketHandle =
                    s_handles [k] then
            ServerSocket1.Socket.Connections[i].SendText(str);
    end;
end;

end.
